{$G+}
PROGRAM CRiMSON_RAiN_Intro;

USES VGAScrl;

CONST
  EndMsg : STRING = 'Diz terrible intro is coded by The GodFader of Pct`98'+#13#10+'$';
  ScrT   : STRING = '    ..ooOO == CRiMSON RAiN == OOoo..    $';

TYPE
  ColorNames = (Red, Green, Blue);
  TPalColor  = ARRAY[ColorNames] OF Byte;
  TPal       = ARRAY[0..255] OF TPalColor;

VAR
  Pal     : TPal;

PROCEDURE Music_Data; EXTERNAL; {$L MUSIC.OBJ  }
PROCEDURE _HscPlayer; EXTERNAL; {$L HSCOBJ.OBJ }

{---------------------------------------------------------------------------}
PROCEDURE StartMusic(Song:Pointer; Polling,OldIRQ:Boolean); ASSEMBLER;
ASM
   MOV  AH, 0
   MOV  BL, Polling
   MOV  BH, OldIRQ
   CMP  BH, 1
   JE   @Invert
   MOV  BH, 1
   JMP  @GoOn
 @Invert:
   XOR  BH, BH
 @GoOn:
   LES  SI, DWORD PTR Song
   CALL _HscPlayer
END;

PROCEDURE StopMusic; ASSEMBLER;
ASM
  MOV  AH, 2
  CALL _HscPlayer
END;
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}


PROCEDURE VRetrace; ASSEMBLER;
ASM
  MOV DX, 03DAh
  @1: IN AL, DX; TEST AL,08h;  JZ @1;
  @2: IN AL, DX; TEST AL,08h; JNZ @2;
END;


{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
PROCEDURE GetVGAPal(VAR APal:TPal); ASSEMBLER;
CONST PalRead=$3C7; PalData=$3C9;
ASM
     LES  DI, APal
     MOV  CX, 256 * 3
     MOV  DX, PalRead  {Write}
     MOV  AL, 0
     OUT  DX, AL       {Set first color}
     MOV  DX, PalData  {Data}
  @Get:
     IN   AL, DX
     STOSB
     LOOP @Get
END;

PROCEDURE SetVGAPal(VAR APal:TPal); ASSEMBLER;
CONST CrtcPort=$3DA; PalWrite=$3C8; PalData=$3C9;
ASM
     PUSH DS
     LDS  SI, APal
     MOV  CX, 256 * 3

     MOV  DX, PalWrite {Write}
     MOV  AL, 0
     OUT  DX, AL       {Set first color}
     MOV  DX, PalData  {Data}

  @Get:
     LODSB
     OUT DX, AL
     LOOP @Get

     POP  DS
END;

PROCEDURE SetIntensity(a1,a2,a3:Byte);
VAR I:Byte;
BEGIN
  Port[$3C8] := $00;
  VRetrace;
  FOR I := 0 TO 255 DO
  BEGIN
    Port[$3C9] := Pal[I,Red]   * a1 DIV 63;
    Port[$3C9] := Pal[I,Green] * a2 DIV 63;
    Port[$3C9] := Pal[I,Blue]  * a3 DIV 63;
  END;
END;

PROCEDURE FadeDownMax;
VAR I:Byte;
BEGIN
  FOR I := 63 DOWNTO 0 DO SetIntensity(I,I,I);
END;

PROCEDURE FadeUpMax;
VAR I:Byte;
BEGIN
  FOR I := 0 TO 63 DO SetIntensity(I,I,I);
END;
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}





{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
PROCEDURE MakeRain;
VAR X,Y,C,D:Word;
BEGIN
  D := 1;
  Randomize;
  FOR X := 0 TO 320 DO
  BEGIN
    C := Random(65);
    FOR Y := 0 TO 200 DO
    BEGIN
      IF C > 64 THEN C := 1;
      Mem[$A000:X+320*Y] := C + 35;
      Inc(C,D);
    END;
    D := Random(5)+1;
  END;
END;
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}



{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
VAR P:Integer;

PROCEDURE RotatePal;
VAR A:Word; B,C:Byte;
BEGIN
  ASM CLI END;
  Inc(P);
  Port[$3C8] := 35;
  A := 100;
  WHILE A > 1 DO
  BEGIN
    B := 1-((A+P) AND 60);
    C := 1-((A+P) AND 65);
    Port[$3C9] := B;
    Port[$3C9] := 0;
    Port[$3C9] := C;
    Dec(A);
  END;
  ASM STI END;
END;
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}



{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
VAR
  ScrOfs:Integer;
  Flag:Boolean;

PROCEDURE Scroll;
BEGIN
  IF Flag
    THEN BEGIN
           Dec(ScrOfs);
           ScrollLeft(ScrOfs,0,ScrOfs+255,7,1);
         END
    ELSE BEGIN
          Inc(ScrOfs);
          ScrollRight(ScrOfs,0,ScrOfs+255,7,1);
         END;
  IF ScrOfs = 1  THEN Flag := False;
  IF ScrOfs = 65 THEN Flag := True;
END;
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}



{ Main routine }
BEGIN
  ScrOfs := 32;
  Flag   := True;

  GetVGAPal(Pal);
  FadeDownMax;
  FillChar(Ptr($A000,0)^,64000,0);

  StartMusic(@Music_Data,False,False);
  ASM
   MOV    AX, $0013
   INT    10h

   CALL   RotatePAL
   CALL   MakeRain

   MOV    AH,9
   MOV    DX, OFFSET ScrT + 1
   INT    21h

 @MainLoop:
   CALL  VRetrace
   CALL  RotatePal
   CALL  Scroll

 @Keypressed:
   IN    AL, 60h
   CMP   AL, 1
   JNE   @MainLoop

   {Stop music}
   CALL StopMusic

   {Restore mode}
   MOV   AX, 3
   INT   10h
   MOV   AH, 9
   MOV   DX, OFFSET EndMSG
   INC   DX
   INT   21h

   { Clear KBuffer & Flags }
   CLI
   MOV   AX, 040h
   MOV   ES, AX
   MOV   AX, WORD PTR ES:[$1C]
   MOV   WORD PTR ES:[$1A], AX { Clear KBD buffer }
   MOV   AX, WORD PTR ES:[$17]
   AND   AX, 0FBh
   MOV   WORD PTR ES:[$17], AX { Mask CTRL flag }
   STI
 END;
END.